# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2021"
rust-version = "1.80"
name = "dnf"
version = "0.2.1"
authors = ["Siargei"]
build = false
exclude = [
    "/.github",
    ".gitignore",
    "target/",
    "Makefile",
]
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Build and evaluate DNF (Disjunctive Normal Form) queries with a fluent API"
homepage = "https://github.com/Asuan/dnf"
documentation = "https://docs.rs/dnf"
readme = "README.md"
keywords = [
    "dnf",
    "query",
    "filter",
    "dsl",
    "expression",
]
categories = [
    "data-structures",
    "parser-implementations",
]
license = "MIT OR Apache-2.0 "
repository = "https://github.com/Asuan/dnf"

[package.metadata.docs.rs]
all-features = true
targets = []

[features]
default = ["derive"]
derive = ["dep:dnf-derive"]
parser = []
serde = ["dep:serde"]

[lib]
name = "dnf"
path = "src/lib.rs"

[[example]]
name = "collections"
path = "examples/collections.rs"
required-features = ["derive"]

[[example]]
name = "custom"
path = "examples/custom_derive.rs"
required-features = ["derive"]

[[example]]
name = "custom_operators"
path = "examples/custom_operators.rs"
required-features = ["derive"]

[[example]]
name = "derive"
path = "examples/derive.rs"
required-features = ["derive"]

[[example]]
name = "hashmap"
path = "examples/hashmap.rs"
required-features = ["derive"]

[[example]]
name = "parser"
path = "examples/parser.rs"
required-features = [
    "parser",
    "derive",
]

[[example]]
name = "serialization"
path = "examples/serialization.rs"
required-features = [
    "serde",
    "parser",
    "derive",
]

[[test]]
name = "hashmap_tests"
path = "tests/hashmap_tests.rs"

[[bench]]
name = "query_benchmarks"
path = "benches/query_benchmarks.rs"
harness = false

[dependencies.dnf-derive]
version = "0.2.1"
optional = true

[dependencies.serde]
version = "1.0"
features = ["derive"]
optional = true

[dependencies.thiserror]
version = "2.0.18"

[dev-dependencies.criterion]
version = "0.8"
features = ["html_reports"]

[dev-dependencies.serde]
version = "1.0"
features = ["derive"]

[dev-dependencies.serde_json]
version = "1.0"
